<?php
/*
 * Copyright 2012-2016 Damien Seguy – Exakat Ltd <contact(at)exakat.io>
 * This file is part of Exakat.
 *
 * Exakat is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * Exakat is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with Exakat.  If not, see <http://www.gnu.org/licenses/>.
 *
 * The latest code can be found at <http://exakat.io/>.
 *
*/


namespace Analyzer\Php;

use Analyzer;

class ConstantScalarExpression extends Analyzer\Analyzer {
    protected $phpVersion = '5.6+';
    
    public function analyze() {
        $validAtoms = array('Integer', 'Float', 'Boolean', 'String', 'Null');

        // const x = 1 + 2;
        $this->atomIs('Const')
             ->outIs('CONST')
             ->outIs('RIGHT')
             ->atomIsNot($validAtoms)
             ->tokenIsNot(array('T_ARRAY', 'T_OPEN_BRACKET'))
             ->back('first');
        $this->prepareQuery();

        // function x( $a = 3 . '3', $b = array())
        $this->atomIs('Function')
             ->outIs('ARGUMENTS')
             ->outIs('ARGUMENT')
             ->atomIs('Assignation')
             ->outIs('RIGHT')
             ->atomIsNot($validAtoms)
             ->tokenIsNot(array('T_ARRAY', 'T_OPEN_BRACKET'))
             ->back('first');
        $this->prepareQuery();
    }
}

?>
